/*
   RainbowCrack - a general propose implementation of Philippe Oechslin's
   faster time-memory trade-off technique.

   Copyright (C) Zhu Shuanglei <shuanglei@hotmail.com>
*/
#ifndef _LCHAINWALKCONTEXT_H
#define _LCHAINWALKCONTEXT_H

#include "HashRoutine.h"
#include "Public.h"
#include "GChainWalkContext.h"


class LCChainWalkContext {
 public:
  LCChainWalkContext(GCChainWalkContext *gctx);
  virtual ~LCChainWalkContext();

 private:
  // Global context
  GCChainWalkContext *m_gctx;

  // Context
  uint64 m_nIndex;
  unsigned char m_Plain[MAX_PLAIN_LEN];
  int m_nPlainLen;
  unsigned char m_Hash[MAX_HASH_LEN];

 public:
  void GenerateRandomIndex();
  void SetIndex(uint64 nIndex);
  void SetHash(unsigned char* pHash);

  void IndexToPlain();
  void PlainToHash();
  void HashToIndex(int nPos);

  uint64 GetIndex();
  string GetPlain();
  string GetBinary();
  string GetPlainBinary();
  string GetHash();
  bool CheckHash(unsigned char* pHash);
};

#endif
